
module type GRAPH =
sig
   type n
   type g
   val new_graph : unit -> g
   val add_node : n -> g -> unit
   val add_link : n -> n -> g -> unit
   val get_nodes : g -> n list
   val print_graph : g -> unit
   val shortest_path : n -> n -> g -> n list
   val shortest_cycle : g -> n list
   val get_strongly_connected : g -> g list
   val read_from_file : string -> g
   val write_to_file : string -> g -> unit
end
